/*
 * Wallpapper autochanger v0.2.0b
 * Copyright (C) 2007 Max Kurilov aka lavelas <m.kurilov@gmail.com>
  * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Further, this software is distributed without any warranty that it is
 * free of the rightful claim of any third person regarding infringement
 * or the like.  Any license provided herein, whether implied or
 * otherwise, applies only to this software file.  Patent licenses, if
 * any, provided herein do not apply to combinations of this program with
 * other software, or any other product whatsoever.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <stdio.h>
#include <zapplication.h>
#include <qdir.h>
#include <qstring.h>

#include <signal.h>
#include <errno.h>
#include <sys/types.h> 
#include <unistd.h>
	
#include "mywidget.h"

#define PIDFILE "/tmp/wpchanger.pid"

MyWidget* mwg;

int main(int argc, char** argv)
{
	FILE* fp;
	
	void sigusr1_handler(int sig);
	if (signal(SIGUSR1, sigusr1_handler) == SIG_ERR) {
		printf("Can't setup SIGUSR1 handler! %s\n", strerror(errno));
	}
	
	if ((fp = fopen(PIDFILE, "r")) != NULL)
	{
		uint pid;
		fscanf(fp, "%i", &pid);
		if ((pid > 0) && QDir( QString("/proc/%1").arg(pid) ).exists())
		{
			printf("Already running! PID=%i\n", pid);
			kill(pid, SIGUSR1);
			fclose(fp);
			return 1;
		}
		freopen(PIDFILE, "w", fp);
	} else {
		fp = fopen(PIDFILE, "w");
	}
	
	fprintf(fp, "%i", getpid());
	fflush(fp);
	
	uint refreshTime = 30;
	if (argc > 1) {
		sscanf(argv[1], "%u", &refreshTime);
	};
	ZApplication app(argc, argv, QApplication::GuiClient);
	mwg = new MyWidget();
    app.showMainWidget(mwg);
    int result = app.exec();

	fclose(fp);
	unlink(PIDFILE);
    return result;
};

void sigusr1_handler(int sig)
{
	if (sig == SIGUSR1) {
		signal(SIGUSR1, sigusr1_handler);
		printf("Seg called!\n");
		mwg->show();
	}
}
