/*
 * Wallpapper autochanger v0.2.0b
 * Copyright (C) 2007 Max Kurilov aka lavelas <m.kurilov@gmail.com>
  * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2.1 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * Further, this software is distributed without any warranty that it is
 * free of the rightful claim of any third person regarding infringement
 * or the like.  Any license provided herein, whether implied or
 * otherwise, applies only to this software file.  Patent licenses, if
 * any, provided herein do not apply to combinations of this program with
 * other software, or any other product whatsoever.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
 
#include <qtimer.h>
#include <ezxres.h>
#include <zmainwidget.h>
#include <ezxutilcst.h>

#include "mycontentwidget.h"

class MyWidget : public ZMainWidget {
    Q_OBJECT
public:
	MyWidget();
	virtual ~MyWidget();

	bool startRefresh(uint refreshTime, bool bNotify = FALSE);
	bool startRefresh(bool bNotify = FALSE);
	void stopRefresh(bool bNotify = FALSE);
	
public slots:
	void changeWP();
	void switchRefresh();
	void HideOrClose();

private:
	void setupGUI();
	void refreshStatus();
	
	uint			m_refreshTime;
	bool			m_isRunning;
	QPopupMenu*		m_popupMenu;
	QPopupMenu*		m_popupMenuService;
	MyContentWidget* m_ContentWidget;
	int				m_midStart;
	int				m_midStop;
	QTimer*			timer;
	RES_ICON_Reader	ir;
	UTIL_CST*		m_CST;
	QLabel*			m_TitleBar;
};
